<?php
// $Id: index.php,v 1.41 2005/07/21 19:05:53 saschalorenz Exp $
	$debug = isset($_REQUEST['debug']) ? 1 : 0;

	include_once "config.inc";

	if (file_exists("local_config.inc")) include_once "local_config.inc";
	include_once "functions.inc";

	if (!file_exists("$data_directory/.isinstalled")) {
		include_once "install.php";
		exit;
	}

	session_start();
	if (isset($_REQUEST['album'])) albumInclude($_REQUEST['album']);
	include_once "language/" . getLanguageInclude($language);

	// display GD error, help folks with lame hosting companies or misconfigured
	// servers and prevents an ugly display of errors
	if (!function_exists('imagejpeg') && $gd_available>=1 && $gd_available<=9) {
		echo $txt_gd_warning;
		log2File("GD not installed, set gd_available to 0 to prevent this errormessage.", TFT_ERROR);
		exit;
	}

	setupStickyURLOptions();
	setGlobal("album");
	setGlobal("page");
	setGlobal("pic");
	setGlobal("thumb");
	setGlobal("table_layout","tl");
	if(!isset($album)){
		$album = "";
	}
	$album_path = $album=="" ? $album_directory : "$album_directory/$album";

	// Set a standard album to start from, if none has been
	// passed over as an URL-parameter

	//check the parameters:
	if(!checkAlbumParamter()) {
		$ip = getenv("REMOTE_ADDR");
		$forbidden_folder = $album;
		log2File("IP $ip trying to access forbidden folder $forbidden_folder. Exiting...", TFT_ERROR);
		header("HTTP/1.0 404 Not Found");
		echo "<b>ACCESS DENIED!</b> <br/>$ip trying to access folder $forbidden_folder.";
		exit();
	}

	// Check if there is a password protected album. If so,
	// show login dialog
	$pwpath = "$album_directory/$album/passwd";
	if(file_exists($pwpath) && ($_SESSION["pw".crc32($album)] != true)) {
		$fd = fopen($pwpath, "r");
		// if php safe mode is activated the _SERVER(PHP_AUTH_PW) is not sent to the script
		$reqpw1 = ""; //$_COOKIE["pw".crc32($album)];
		$reqpw2 = crypt($_POST['PHP_AUTH_PW'],"tftgallery");
		$reqpw3 = crypt($_SERVER['PHP_AUTH_PW'],"tftgallery");
		$givenpw = fgets($fd,15);
		fclose($fd);
		if(($reqpw1 != $givenpw) && ($reqpw2 != $givenpw) && ($reqpw3 != $givenpw)) {
			include_once "401access.inc";
			exit;
		}
		$_SESSION["pw".crc32($album)]=true;
	}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<title><?php echo $GLOBALS['txt_title']; ?></title>
<meta name="generator" content="TFT Gallery <?php echo TFT_VERSION; ?> http://tftgallery.sf.net/" />
<?php
	if($searchengine)
		echo "<meta name='robots' content='index, follow' />\n";
	else
		echo "<meta name='robots' content='noindex, nofollow' />\n";
	if ($debug) {
		echo "<!"."-- style references -->\n";
		echo "<!"."-- tried %_REQUEST['style'] styles/${_REQUEST['style']} '" . isset($_REQUEST['style']) . ":" . file_exists("styles/${_REQUEST['style']}") . "' -->\n";
		echo "<!"."-- tried %{_COOKIE['personal_style'] styles/${_COOKIE['personal_style']} '" . isset($_COOKIE['personal_style']) . ":" . file_exists("styles/${_COOKIE['personal_style']}") . "' -->\n";
		echo "<!"."-- tried %GLOBALS['standard_style'] styles/${GLOBALS['standard_style']} '" . isset($GLOBALS['standard_style']) . ":" . file_exists("styles/${GLOBALS['standard_style']}") . "' -->\n";
		echo "<!"."-- tried %styles/default.css styles/default.css '" . file_exists("styles/default.css") . "' -->\n";
	}
	// URL override
	if (isset($_REQUEST['style']) && file_exists("styles/${_REQUEST['style']}")) {
		if ($debug) echo "<!"."-- 1 TRUE tried styles/${_REQUEST['style']} -->\n";
		$style_sheet = $_REQUEST['style'];
	}
	// personal setting
	elseif (isset($_COOKIE['personal_style']) && file_exists("styles/${_COOKIE['personal_style']}")) {
		if ($debug) echo "<!"."-- 2 TRUE tried styles/${_COOKIE['personal_style']} -->\n";
		$style_sheet = $_COOKIE['personal_style'];
	}
	// web site setting
	elseif (isset($GLOBALS['standard_style']) && file_exists("styles/${GLOBALS['standard_style']}")) {
		if ($debug) echo "<!"."-- 3 TRUE tried styles/${GLOBALS['standard_style']} -->\n";
		$style_sheet = $GLOBALS['standard_style'];
	}
	// default
	elseif (file_exists("styles/default.css")) {
		if ($debug) echo "<!"."-- 4 TRUE tried styles/default.css " . file_exists("styles/default.css") . " -->\n";
		$style_sheet = "default.css";
	} else {
		echo "<style>\n";
		echo ".body { background-color: #e0e0e0; } \n";
		echo ".title, .naviarea, .mainarea, .location, .footer { margin: 3px; padding: 10px; border: 2px solid black; vertical-align: top; background-color: #b0b0b0;} \n";
		echo "div.naviarea { padding-left: 2px; float: left; width: 250px; } \n";
		echo "div.mainarea{ margin-left: 270px; text-align: center;} \n";
		echo "td.naviarea{ width: 1%; padding: 10px; vertical-align: top; white-space: nowrap; max-width: 250px; } \n";
		echo "td.mainarea{ width: 99%; vertical-align: top; text-align: center;} \n";
		echo "</style>\n";
	}

	d("Style: '$style_sheet'");
	// selected style shhet
	if (isset($style_sheet)) {
	  	echo "<link rel='stylesheet' type='text/css' href='styles/$style_sheet'/>\n";
	}
	// styles specific override
  	if (file_exists("styles/local.css")) {
		echo "<link rel='stylesheet' type='text/css' href='styles/local.css'/>\n";
	}
	// folder specific overides for styles
  	if (file_exists("styles/local_$style_sheet")) {
		echo "<link rel='stylesheet' type='text/css' href='styles/local_$style_sheet'/>\n";
	}
  	if (isset($_REQUEST['album']) && false!==($folder_css = albumStyleSheet($_REQUEST['album']))) {
	  	echo "<link rel='stylesheet' type='text/css' href='$folder_css'/>\n";
	}
?>
</head>
<body class="body">

<?php if ($debug) print_r($_COOKIE); ?>
<div class="title">
	<?php
		echo "$txt_title\n";
	?>
</div>

<div class="location">
	<?php
		require "location.php";
	?>
</div>

<?php
if ($table_layout) {
	// table layout
	echo "<table class='maintable'><tr>\n";
	echo "<td class='naviarea'>\n";
		require "navigation.php";
		if((! $cart_only_for_admin) || !empty($_SESSION['admin'])) {
			require "cart.php";
		}
	echo "</td>\n";
	echo "<td class='mainarea'>\n";
			if(isset($page) && $page=="settings") {
			require "settingsform.php";
		}
		elseif(isset($pic)) {
			require "picture.php";
		}
		elseif(isset($page)) {
			require "thumbnails.php";
		}
		else {
			echo $txt_welcome_message;
		}
	echo "</td>\n";
	echo "</tr></table>\n";
} else {
	// div layout
	echo "<div class='leftarea'>\n";
	echo "<div class='naviarea'>\n";
	require "navigation.php";
	if((! $cart_only_for_admin) or !empty($_SESSION['admin'])) {
		require "cart.php";
	}
	echo "</div>\n\n";
	echo "</div>\n\n";
	echo "<div class='mainarea'>\n";
		if(isset($page) && $page=="settings") {
			require "settingsform.php";
		}
		elseif(isset($pic)) {
			require "picture.php";
		}
		elseif(isset($page)) {
			require "thumbnails.php";
		}
		else {
			echo $txt_welcome_message . "\n\n";
		}
	echo "</div>\n\n";
}

require "footer.php";
?>
</body>
</html>
