<?php
// $Id: scale.php,v 1.4 2005/03/14 20:33:19 saschalorenz Exp $
	include_once "config.inc";
	if (file_exists("local_config.inc")) include_once "local_config.inc";
	include_once "functions.inc";

	if(!isset($_REQUEST['picture'])){
		// No valid $picture parameter, exit with an error
		// A valid $picture parameter is the path to a picture.
		errorExit();
	}
	$picture = $_REQUEST['picture'];

	if(validScaledExists($picture)){
		// There's already a valid scaled, so just show it.
		header("Content-Type: image/jpg");
		header("Content-Transfer-Encoding: binary");
		readfile(getScaledURL($picture));
		exit();
	}
	else{
		// Is it a picture?
		if(preg_match($GLOBALS['pic_extentions'],$picture)){
			// There's no valid scaled, so we need to generate it:
			// Check if GD is enabled. If not, exit with error
			if($GLOBALS["gd_available"] > 0){
				header("Content-Type: image/jpg");
				header("Content-Transfer-Encoding: binary");
				createScaled($picture,true);
				exit();
			}
			else{
				header("Content-Type: image/gif");
				header("Content-Transfer-Encoding: binary");
				readfile("images/default_GDError.gif");
				exit();
			}
		}
		else{
			// It's not a picture! Should a default scaled be displayed?
			if(preg_match($GLOBALS['other_extentions'],$picture)){
				foreach($GLOBALS['thumb_map'] as $pat => $filename) {
					if (substr($pat,0,1)=="/" && preg_match($pat,$picture)) {
						header("Content-Type: image/gif");
						header("Content-Transfer-Encoding: binary");
						readfile($filename);
						exit();
					}
				}
			}
			else{
				errorExit();
			}

		}

	}

// createScaled($pic): creates a scaled for an specified image and saves it.
// $pic: path to the picture
// $output: send jpeg to output
function createScaled($pic,$output = true){
	global $data_directory;
	// Open the picture and get it's size
	if (preg_match("/\.(jpg|jpeg)/i",$pic)) {
		$image = imagecreatefromjpeg("$pic");
	} elseif (preg_match("/\.png/i",$pic)) {
		$image = imagecreatefrompng("$pic");
	} elseif (preg_match("/\.gif/i",$pic)) {
		$image = imagecreatefromgif("$pic");
	}

	$image_x = imagesx($image);
	$image_y = imagesy($image);

	// Calculate size of scaled depending on _height/_width
	$new_height = $GLOBALS["max_picture_height"];
	$new_width = $GLOBALS["max_picture_width"];
	if($image_x > $GLOBALS["max_picture_width"] || $image_y > $GLOBALS["max_picture_height"]){
		//decide which dimension to scale down:
		if(($image_x / $image_y) > ($GLOBALS["max_picture_width"] / $GLOBALS["max_picture_height"])){
			$new_width = $GLOBALS["max_picture_width"];
			$new_height = ($GLOBALS["max_picture_width"] / $image_x) * $image_y;
		}
		else{
			$new_height = $GLOBALS["max_picture_height"];
			$new_width = ($GLOBALS["max_picture_height"] / $image_y) * $image_x;
		}
	}

	// create empty scaled and copy(resized) the picture
	if($GLOBALS["gd_available"] == 2){
		$scaled = imagecreatetruecolor($new_width, $new_height);
		imagecopyresampled($scaled, $image, 0, 0, 0, 0, $new_width, $new_height, $image_x, $image_y);
	}
	else{
		$scaled = imagecreate($new_width, $new_height);
		imagecopyresized($scaled, $image, 0, 0, 0, 0, $new_width, $new_height, $image_x, $image_y);
	}

	if ($GLOBALS[server_scaled_caching]) {
		//create the neeeded subdirectories for this scaled
		$elements = explode("/", "scaled/$pic");
		$cwd = getcwd();
		chdir($data_directory);
		for($i = 0; $i < (count($elements) - 1); $i++){
			@mkdir($elements[$i], 0777);
			chdir($elements[$i]);
		}
		chdir($cwd);

		// save the scaled
		imagejpeg($scaled, getScaledURL($pic), $GLOBALS["server_scaled_quality"]);
	}
	if ($output) imagejpeg($scaled, '', $GLOBALS["server_scaled_quality"]);
	imagedestroy($image);
	imagedestroy($scaled);

}

// errorExit(): exits the script showing an image indicating an error.
function errorExit(){
	header("Content-Type: image/gif");
	header("Content-Transfer-Encoding: binary");
	readfile("images/default_error.gif");
	exit();
}

?>